release vars all
release procs all
; File name: DEMO.SC
;
; Script to build library and then execute the demo
;

message "Making library - Please wait.."

play "Chkl"       ;  Build floating button library

message "Creating lib DEMO, Please wait .."
createlib "demo"
release procs wproc
 proc wproc(x)
    execute "writelib \"demo\" " + x
    + " release procs " + x
 endproc


;======================================================= Demo_Menu_Proc
proc Demo_Menu_Proc
; Display DEMO menu
(
)
clearspeedbar
prompt ""

showpulldown
"Demo"
    : "Checklist demo"
    : "Demo",
"Words"
    : "Read the documentation"
    : "Words"
    submenu
    "Readme"
    	: "View the $$README file via the Paradox editor"
    	: "Words/Readme",
    "ProcDoc"
    	: "View procedure documentation via the Paradox editor"
    	: "Words/ProcDoc"
    endsubmenu,
"Exit"
    : "Exit from demo"
    : "Exit"
endmenu

endproc
wproc( "Demo_Menu_Proc" )

;======================================================= Demo_1
proc Demo_1
; Demo a form that looks like a dialog box
(
)
private x, y, z
	, check.list
	, check.label
	, tf.list
	, check.y
	, check.n

dynarray check.list[]
check.list[  1 ] = "AK     Alaska"
check.list[  2 ] = "AL     Alabama"
check.list[  3 ] = "AR     Arkansas"
check.list[  4 ] = "AZ     Arizona"
check.list[  5 ] = "CA     California"
check.list[  6 ] = "CO     Colorado"
check.list[  7 ] = "CT     Connecticut"
check.list[  8 ] = "DC     Dist of Columbia"
check.list[  9 ] = "DE     Delaware"
check.list[ 10 ] = "FL     Florida"
check.list[ 11 ] = "GA     Georgia"
check.list[ 12 ] = "HI     Hawaii"
check.list[ 13 ] = "IA     Iowa"
check.list[ 14 ] = "ID     Idaho"
check.list[ 15 ] = "IL     Illinois"
check.list[ 16 ] = "IN     Indiana"
check.list[ 17 ] = "KS     Kansas"
check.list[ 18 ] = "KY     Kentucky"
check.list[ 19 ] = "LA     Louisiana"
check.list[ 20 ] = "MA     Massachussets"
check.list[ 21 ] = "MD     Maryland"
check.list[ 22 ] = "ME     Maine"
check.list[ 23 ] = "MI     Michigan"
check.list[ 24 ] = "MN     Minnisota"
check.list[ 25 ] = "MO     Missouri"
check.list[ 26 ] = "MS     Mississippi"
check.list[ 27 ] = "MT     Montana"
check.list[ 28 ] = "NC     North Carolina"
check.list[ 29 ] = "ND     North Dakota"
check.list[ 30 ] = "NE     Nebraska"
check.list[ 31 ] = "NH     New Hampshire"
check.list[ 32 ] = "NJ     New Jersey"
check.list[ 33 ] = "NM     New Mexico"
check.list[ 34 ] = "NV     Nevada"
check.list[ 35 ] = "NY     New York"
check.list[ 36 ] = "OH     Ohio"
check.list[ 37 ] = "OK     Oklahoma"
check.list[ 38 ] = "OR     Oregon"
check.list[ 39 ] = "PA     Pennsylvania"
check.list[ 40 ] = "RI     Rhode Island"
check.list[ 41 ] = "SC     South Carolina"
check.list[ 42 ] = "SD     South Dakota"
check.list[ 43 ] = "TN     Tennessee"
check.list[ 44 ] = "TX     Texas"
check.list[ 45 ] = "UT     Utah"
check.list[ 46 ] = "VA     Virginia"
check.list[ 47 ] = "VT     Vermont"
check.list[ 48 ] = "WA     Washington"
check.list[ 49 ] = "WI     Wisconsin"
check.list[ 50 ] = "WV     West Virginia"
check.list[ 51 ] = "WY     Wyoming"

dynarray tf.list[]
for x from 1 to dynarraysize( check.list )
	tf.list[ x ] = false
endfor

check.label = "State  Name               Mail?"
check.y = "    Yes"
check.n = "    No"

Chkl_ChkList_Dlg( check.list, tf.list, "Select States for Mailing"
	, check.label, check.y, check.n, true, "" )

; Show the blank desktop to the user

echo normal echo off

endproc
wproc( "Demo_1" )

;===================================================== Demo_Word_Wrap
proc Demo_Word_Wrap
; Word wraps a string.
;
; Return Value:
; None.
; 
; This proc updates the dynarray parameter as follows:
;
;   str["lines"] is set to the number of lines.
;
;   str["longest"] is set to the length of the longest line after
;   wrapping.  This value will be less than or equal to str["width"].
;
;   str[n] is set to the contents of line n, 
;   where 1 <= n <= str["lines"].
(
    str     ; {I,O} Dynarray that contains the string to be word 
            ;       wrapped in the element str["string"] and the 
            ;       wrapping width in str["width"].
            ;       Wrapping width must be between 1 and 255.
)
private x, y
    , z            ; string from str["string"]
    , w            ; wrap width from str["width"]
    , s            ; current start pos in z
    , e            ; current end pos in z
    , sz        ; length of substring in z
    , lz        ; length of z

; Check parameters in str

if isassigned( str["string"] ) then
    z = str["string"]
else
    z = ""
endif

if isassigned( str["width"] ) then
    w = numval( str["width"] )
    if lower( strval( w ) ) = "error" then
        w = 20   ; default width
        z = z + "\n*** Invalid width passed ***"
    endif
    if w < 1 or w > 255 then
        w = 20   ; default width
        z = z + "\n*** Invalid width passed ***"
    endif
else
    w = 20       ; default width
    z = z + "\n*** No width passed ***"
endif

; Word wrap lines

str["lines"] = 0
str["longest"] = 0
s = 1
e = 1
lz = len( z )

while s <= lz
    e = searchfrom( "\n", z, s )
    if e > 0 and e - s <= w then
        sz = e - s   ; don't include \n
    else
        ; There is no \n in the w bytes starting at s.
        ; Look for rightmost blank or dash in string of width w.
        sz = 0
        e = s + w - 1
        while e > s and e < lz
            if substr( z, e, 1 ) = " " then
                sz = e - s  ; don't include trailing blank
                quitloop
            endif
            if substr( z, e, 1 ) = "-" then
                sz = e - s + 1 ; include trailing dash
                quitloop
            endif
            e = e - 1
        endwhile
        if sz = 0 then
            ; no natural breaks in line or at end of string - use 
            ; maximum width
            e = s + w -1
            e = min( e, lz )
            sz = e - s + 1
        endif
    endif
    ; trim trailing blanks from line (caller may want to center lines)
    y = substr( z, s, sz )
    while match( y, ".. ", y ) endwhile

    str["lines"] = str["lines"] + 1
    str[ str["lines"] ] = y
    if len( y ) > str["longest"] then
        str["longest"] = len( y )
    endif
    s = e + 1
endwhile

endproc
wproc( "Demo_Word_Wrap" )


message "Initializing DEMO"

autolib = "chkl,demo"

Demo_Menu_Proc()
prompt ""

message ""

echo normal

while true
    getevent message "menuselect" to evt
    switch
    case evt[ "menutag" ] = "Demo" :
    	echo off
    	showpulldown endmenu
        Demo_1()
		Demo_Menu_Proc()
		echo normal
    case evt[ "menutag" ] = "Words/Readme" :
        echo off
        editor open "$$README"
        window handle editor to edithand
        window maximize edithand
        clearpulldown
        echo normal
        while iswindow( edithand )
            getevent all to evtx
            execevent evtx
        endwhile
        Demo_Menu_Proc()
        release vars edithand, evtx
    case evt[ "menutag" ] = "Words/ProcDoc" :
        echo off
    	if not isfile( "chkl.doc" ) then
    		message "Extracting proc documentation from .SC files",
    			"   Please wait .."
    		sleep 1000
    		play "chkl-doc"
    	endif
        editor open "chkl.doc"
        window handle editor to edithand
        window maximize edithand
        clearpulldown
        echo normal
        while iswindow( edithand )
            getevent all to evtx
            execevent evtx
        endwhile
        Demo_Menu_Proc()
        release vars edithand, evtx
    case evt[ "menutag" ] = "Exit" :
        quitloop
    otherwise :
        message "Unrecognized menutag: \"", evt[ "menutag" ], "\""
        quitloop
    endswitch
endwhile

message "DEMO is done"
sleep 1000

release vars evt


